=== debian/changelog ===
slicer (3.6.3~svn16592-1) unstable; urgency=low

  * New upstream snapshot
  * Switched to CDBS
  * Include <stddef.h> to ensure ptrdiff_t is defined. (Closes: #625103)
  * Set -DBUILD_BRAINSTOOLS:BOOL=ON
  * Removed modules under development
  * Changed menu section to Education;Science;MedicalSoftware;
  * Bump compat level to 8
  * Bump Standards-Version: 3.9.2

 -- Dominique Belhachemi <domibel@debian.org>  Mon, 09 May 2011 21:02:12 -0400
