=== debian/rules ===
#!/usr/bin/make -f

# Set this value to 0/1 to turn off/on verbose mode.
export DH_VERBOSE=0

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk

DEB_BUILD_PARALLEL := true

DEB_CMAKE_EXTRA_FLAGS = \
              -DCMAKE_INSTALL_PREFIX:PATH=/usr \
              -DCMAKE_BUILD_TYPE:STRING=Release \
              -DCMAKE_VERBOSE_MAKEFILE:BOOL=$(DH_VERBOSE) \
              -DVOLUMERENDERINGMODULE:BOOL=ON \
              -DCMAKE_SKIP_RPATH:BOOL=OFF \
              -DBUILD_TESTING:BOOL=ON \
              -DCMAKE_SHARED_LINKER_FLAGS:STRING="-Wl,--as-needed" \
              -DCMAKE_EXE_LINKER_FLAGS:STRING="-Wl,--as-needed" \
              -DSlicer3_USE_IGSTK:BOOL=OFF \
              -DSlicer3_USE_OPENIGTLINK:BOOL=ON \
              -DSlicer3_USE_MIDAS:BOOL=ON \
              -DSlicer3_WITH_LIBRARY_VERSION:BOOL=ON \
              -DBUILD_BRAINSTOOLS:BOOL=ON \
              -DSlicer3_USE_PYTHON:BOOL=ON

DEB_DH_SHLIBDEPS_ARGS_slicer := -l$(CURDIR)/debian/tmp/usr/lib:$(CURDIR)/debian/tmp/usr/lib/Slicer3:$(CURDIR)/debian/tmp/usr/lib/Slicer3/Modules:$(CURDIR)/debian/tmp/usr/lib/Slicer3/Plugins
DEB_DH_SHLIBDEPS_ARGS_libslicer3 := -l$(CURDIR)/debian/tmp/usr/lib:$(CURDIR)/debian/tmp/usr/lib/Slicer3:$(CURDIR)/debian/tmp/usr/lib/Slicer3/Modules:$(CURDIR)/debian/tmp/usr/lib/Slicer3/Plugins

build/slicer::
	mkdir -p $(DEB_BUILDDIR)/lib/Slicer3
	echo "build `uname -m`\nbuildDate `date +"%Y-%m-%d"`\nsvnurl http://svn.slicer.org/Slicer3/trunk\nsvnrevision 16592" > $(DEB_BUILDDIR)/lib/Slicer3/Slicer3Version.txt

install/slicer::
	# remove empty directories
	rmdir    $(CURDIR)/debian/tmp/usr/share/Slicer3/Modules/ModelIntoLabelVolume/Testing/TestData/
	rmdir    $(CURDIR)/debian/tmp/usr/share/Slicer3/Modules/ModelIntoLabelVolume/Testing/
	rmdir    $(CURDIR)/debian/tmp/usr/share/Slicer3/Modules/ModelIntoLabelVolume/

	chmod +x $(CURDIR)/debian/tmp/usr/lib/Slicer3/Modules/SlicerDaemon/Tcl/slicerget.tcl
	chmod +x $(CURDIR)/debian/tmp/usr/lib/Slicer3/Modules/SlicerDaemon/Tcl/slicerput.tcl
	chmod +x $(CURDIR)/debian/tmp/usr/lib/Slicer3/Modules/SlicerDaemon/Tcl/tracker/tracker.tcl
	chmod +x $(CURDIR)/debian/tmp/usr/lib/Slicer3/SlicerBaseGUI/Tcl/ExternalProgress.tcl
	chmod +x $(CURDIR)/debian/tmp/usr/lib/Slicer3/launch.tcl
	chmod +x $(CURDIR)/debian/tmp/usr/share/FreeSurfer/Testing/fips2mrml.tcl
#	chmod +x $(CURDIR)/debian/tmp/usr/share/Slicer3/Modules/ChangeTracker/Simulation/create_artificial_growth_deformation.sh
	chmod +x $(CURDIR)/debian/tmp/usr/share/Slicer3/Modules/QueryAtlas/Tcl/QueryAtlasFips2Mrml.tcl
	chmod -x $(CURDIR)/Utilities/Launcher/3DSlicerLogoICOimages/3DSlicerLogo-DesktopIcon-48x48x256.png

	dh_install --sourcedir=$(CURDIR)/debian/tmp --list-missing

get-orig-source:
	/bin/sh $(CURDIR)/debian/get-orig-source
